/*
  Name: Trabalho de Linguagem III
  Copyright: pode copiar, se tiver coragem e entender, pois nem eu entendo mais!
  Author: Douglas Pasqualin e Carlos Burger
  Date: 03/12/07 00:23
  Description: Programa pra consertar (ou piorar) legendas bugadas que se baixa da Internet
*/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <strings.h>
#include <math.h>

#define TAM 100
#define ARQ "C:\leg.srt"

struct tempo {
  int hora;
  int min;
  int seg;
  float mil;
};

struct propor {
  float x;
  float y;
};

int GetLinha(FILE *fp, char *linha) {
     char c;
     int i, pos;
     pos = ftell(fp);
     for(i=0; i<TAM; i++) {
       linha[i] = getc(fp);
       if (linha[i] == '\n') {
         linha[i] = '\0';
         break;
       }
     }
     return pos;
}

float ConverteParaSegundos(struct tempo h) {
     float seg;
     seg = ((h.hora * 3600) + (h.min * 60) + h.seg) + (h.mil / 1000);
     return seg;
}

float QuantidadeProporcional(float tempoatual, float seg, float tempo) {
      float seginc;
      seginc = (tempoatual * seg) / tempo;
      return seginc;
}

void ConverteParaLinhaNoEstiloPOG(struct tempo h1, struct tempo h2, char *linha) {
     char h[3], m[3], s[3], mil[4];
     itoa(h1.hora, h, 10);
     itoa(h1.min, m, 10);
     itoa(h1.seg, s , 10);
     itoa(h1.mil, mil, 10);
  /*Primeira Parte*/
     if (h[1] == '\0') {
       linha[0] = '0'; 
       linha[1] = h[0];
     }
     else {
       linha[0] = h[0];
       linha[1] = h[1];
     }
     linha[2] = ':';
     if (m[1] == '\0') {
       linha[3] = '0'; 
       linha[4] = m[0];
     }
     else {
       linha[3] = m[0];
       linha[4] = m[1];
     }
     linha[5] = ':';
     if (s[1] == '\0') {
       linha[6] = '0'; 
       linha[7] = s[0];
     }
     else {
       linha[6] = s[0];
       linha[7] = s[1];
     }     
     linha[8] = ',';
     if (mil[1] == '\0') {
       linha[9] = '0';
       linha[10] = '0';
       linha[11] = mil[0];
     } 
     else if (mil[2] == '\0') {
       linha[9] = '0';
       linha[10] = mil[0];
       linha[11] = mil[1];
     }
     else {
       linha[9] = mil[0];
       linha[10] = mil[1];
       linha[11] = mil[2];
     }
     linha[12] = '\0';
  /*Coloca a setinha :D*/
     linha = strcat(linha, " --> ");
  /*Let's Botemo para a segunda parte, e viva a POG!!!*/
     itoa(h2.hora, h, 10);
     itoa(h2.min, m, 10);
     itoa(h2.seg, s , 10);
     itoa(h2.mil, mil, 10);
     if (h[1] == '\0') {
       linha[17] = '0'; 
       linha[18] = h[0];
     }
     else {
       linha[17] = h[0];
       linha[18] = h[1];
     }
     linha[19] = ':';
     if (m[1] == '\0') {
       linha[20] = '0'; 
       linha[21] = m[0];
     }
     else {
       linha[20] = m[0];
       linha[21] = m[1];
     }
     linha[22] = ':';
     if (s[1] == '\0') {
       linha[23] = '0'; 
       linha[24] = s[0];
     }
     else {
       linha[23] = s[0];
       linha[24] = s[1];
     }     
     if (mil[1] == '\0') {
       linha[26] = '0';
       linha[27] = '0';
       linha[28] = mil[0];
     } 
     else if (mil[2] == '\0') {
       linha[26] = '0';
       linha[27] = mil[0];
       linha[28] = mil[1];
     }
     else {
       linha[26] = mil[0];
       linha[27] = mil[1];
       linha[28] = mil[2];
     }
     linha[29] = '\0';
}

void CalculaHora(float seginc, char *l, int flag, struct propor tempo) {
     struct tempo h1, h2;
     float seg1, seg2;
     double partint;
     int r, segaux;
     char t[4];
  /*Pega os primeiros tempos*/
     h1.hora = ((l[0] - '0') *10) + (l[1] - '0');
     h1.min =  ((l[3] - '0') *10) + (l[4] - '0');
     h1.seg =  ((l[6] - '0') *10) + (l[7] - '0');
     h1.mil =  ((l[9] - '0') *100) + ((l[10] - '0') *10) + (l[11] - '0');
  /*Pega os segundos tempos*/
     h2.hora = ((l[17] - '0') *10) + (l[18] - '0');
     h2.min =  ((l[20] - '0') *10) + (l[21] - '0');
     h2.seg =  ((l[23] - '0') *10) + (l[24] - '0');
     h2.mil =  ((l[26] - '0') *100) + ((l[27] - '0') *10) + (l[28] - '0');
  /*Transforma tudo para segundos*/
     seg1 = ConverteParaSegundos(h1);
     if (flag) {
       seginc = QuantidadeProporcional(seg1, tempo.x, tempo.y);
     }
     seg1 = seg1 + seginc;
  /*Converte de Volta para String*/
     segaux = (int)floor((seg1));
     h1.hora = segaux / 3600;
     r = segaux % 3600;
     h1.min = r / 60;
     h1.seg = r % 60;
     h1.mil = round(modf(seg1, &partint) * 1000);
  /*Transforma tudo para segundos*/
     seg2 = ConverteParaSegundos(h2);
     if (flag) {
       seginc = QuantidadeProporcional(seg2, tempo.x, tempo.y);
     }
     seg2 = seg2 + seginc;     
  /*Converte de Volta para String*/
     segaux = (int)floor((seg2));
     h2.hora = segaux / 3600;
     r = segaux % 3600;
     h2.min = r / 60;
     h2.seg = r % 60;
     h2.mil = round(modf(seg2, &partint) * 1000);      
     ConverteParaLinhaNoEstiloPOG(h1, h2, l);
 
     printf("\n%s", l);
}

int AcrescentaSegundos(FILE *fp, float seg, char leg[4]) {
  char linha[30];
  int i, pos;
  struct propor x;
  while (!feof(fp)) {
    GetLinha(fp, linha);
    if (!strcmp(linha, leg)) {
      pos = GetLinha(fp, linha);
      CalculaHora(seg, linha, 0, x);
      fseek(fp, pos, SEEK_SET);
      fputs(linha, fp);
      return 1;
      break;
    }
  }
}

int AcrescentaSegundosTodos(FILE *fp, float seg) {
  char linha[100], aux[4];
  int leg, posgravar, poscur;
  struct propor x;
  leg = 1;
  while (!feof(fp)) {
    GetLinha(fp, linha);
    itoa(leg, aux, 10);
    if (!strcmp(linha, aux)) {
      posgravar = GetLinha(fp, linha);
      poscur = ftell(fp);
      CalculaHora(seg, linha, 0, x);
      fseek(fp, posgravar, SEEK_SET);
      fputs(linha, fp);
      fseek(fp, poscur, SEEK_SET);
      leg++;
    }
  }
  return leg-1;
}

int AcrescentaSegundosProporcional(FILE *fp, struct propor tempo) {
  char linha[100], aux[4];
  int leg, posgravar, poscur;
  leg = 1;
  while (!feof(fp)) {
    GetLinha(fp, linha);
    itoa(leg, aux, 10);
    if (!strcmp(linha, aux)) {
      posgravar = GetLinha(fp, linha);
      poscur = ftell(fp);
      CalculaHora(tempo.x, linha, 1, tempo);
      fseek(fp, posgravar, SEEK_SET);
      fputs(linha, fp);
      fseek(fp, poscur, SEEK_SET);
      leg++;
    }
  }
  return leg-1;
}

main (void) {
  struct propor tempo;
  int escolha, total;
  float segundos, t;
  char caminho[200], nroleg[4];
  FILE *sub;

  sub = NULL;
  sub = fopen(ARQ, "r+");
  while (escolha!=5) {
    system("cls"); 
    printf("\n\n================ MENU ================\n\n");
    printf("1 - Informar nome do arquivo \n");
    if (sub != NULL) {
      printf("2 - Acrescentar segundos a uma legenda X \n");
      printf("3 - Acrescentar segundos a todas legendas \n");
      printf("4 - Acrescentar segundos proporcionalmente \n");    
    }
      printf("5 - Sair \n\n");
    printf("\nEscolha uma opcao: ");
    scanf("%d",&escolha);
    switch (escolha) {
      case 1: {
        printf("\nInforme o caminho completo do arquivo a ser aberto\n");
        scanf("%s",caminho);
        if ((sub = fopen(caminho,"r+")) == NULL) {
          printf("Erro ao abrir arquivo\n");
          getch();
        }
      break;
      }
      case 2: {
        printf("\nInforme quantos segundos devem ser alterados: ");
        scanf("%f", &segundos);
        printf("\nInforme o numero da legenda: ");
        scanf("%s", nroleg);
        total = AcrescentaSegundos(sub, segundos, nroleg);
        printf("\nFeito, %d legenda alterada!", total);
        fclose(sub);
        getch();
        sub = NULL;
        break;
      }
      case 3: {
        printf("\nInforme quantos segundos devem ser alterados: ");
        scanf("%f", &segundos);
        total = AcrescentaSegundosTodos(sub, segundos);
        printf("\nFeito, %d legendas alteradas", total);
        fclose(sub);
        getch();
        sub = NULL;
        break;
      }
      case 4: {
        printf("\nInforme quantos segundos devem ser alterados: ");
        scanf("%f", &tempo.x);
        printf("\nA cada quantos segundos? ");
        scanf("%f", &tempo.y);
        total = AcrescentaSegundosProporcional(sub, tempo);
        printf("\nFeito, %d legendas alteradas", total);
        fclose(sub);
        getch();     
        sub = NULL;
        break;
      }
      default: {
          if(escolha==5) {
             continue;
          }
        printf("\n\n\nNenhuma opcao foi escolhida ");
        getch();
        break;
      }
    }
  }
  if(escolha==5) {
    if (sub != NULL) fclose(sub);
    printf("\n\n\nPrograma encerrado");
  }
  getch(); 
}
